

import java.applet.*;
import java.awt.*;
import java.awt.image.*;


/* "hatch extends water" means that there are a lot
	of routines in water.java that this applet imports
	and uses, so if you want to understand this code,
	read and understand water.java first.

	The routines in this file replace those in water.java
	that have the same names. This is called "class inheritance".
	This allows a small amount of code to slightly modify
	existing programs that can be very large.

	Anyway. This is my bit for Java toy-making. I am Neal McDonald,
	this is my code, take and eat, but leave in a pointer to me:
	www.workly.com
	*/

public class hatch extends water {
	int pathMakers;
	int p2init;

	void initPart(int which) {
		int r, g, b, cx, cy;
		double gx, gy;

		if (which<pathMakers) {
			gx = Math.random() * imageX * imageXscale;
			gy = Math.random() * imageY * imageYscale;

			parts[which][DIR] = Math.random() *360.0;
			parts[which][UPD] = 999999999.0;
			parts[which][JUMPED] = 0.0;
			parts[which][SPEED] = 4.0;

			partColors[which] = Color.white;
			parts[which][XPOS] = gx;
			parts[which][YPOS] = gy;
		} else {
			parts[which][UPD] = -1.0;
		}
	}


	void initPartB(int which, int source) {
		int r, g, b, cx, cy;
		double gx, gy;

		gx = parts[source][XPOS];
		gy = parts[source][YPOS];

		parts[which][DIR] = parts[source][DIR]+90;
		parts[which][UPD] = 2.0;
		parts[which][JUMPED] = 0.0;
		parts[which][XPOS] = gx;
		parts[which][YPOS] = gy;

		b = getColorG((int)gx, (int)gy);

		if ((which%2)==0) {
			partColors[which] = Color.black;
			gx = (((double)(256-b)) / 256.0) * 5.0;
			parts[which][SPEED] = gx;
		} else {
			partColors[which] = Color.white;
			gx = (((double)b) / 256.0) * 5.0;
			parts[which][SPEED] = gx;
		}
	}


	void initMore() {
		pathMakers =
			java.lang.Integer.parseInt(getParameter("pathMakers"));
		p2init = pathMakers;
	}

	void drawPart(Graphics gr, int which) {
		int px,py,ox,oy;

		if (which>=pathMakers) {
			if (parts[which][UPD] >0.0) {
				if (parts[which][JUMPED] < 0.01) {
					if (parts[which][SPEED] > 1.0) {
						px = ((int)parts[which][XPOS]);
						py = ((int)parts[which][YPOS]);
						ox = ((int)parts[which][OX]);
						oy = ((int)parts[which][OY]);

						parts[which][UPD] -= 1.0;
						r_setColor(gr, partColors[which]);
						r_drawLine(gr, px,py,ox,oy);
					}
				}
			}
		}
	}

	void movePart(int which) {
		double dx, dy;
		int ix, jumped;

		if (which<pathMakers) {
			initPartB(p2init, which);
			++p2init;
			if (p2init==NUM_PARTS) { p2init=pathMakers; }
		}

		ix = (int)(parts[which][DIR]) % 360;
		if (ix<0) ix+=360;
		parts[which][OX] = parts[which][XPOS];
		parts[which][OY] = parts[which][YPOS];
		parts[which][XPOS] += parts[which][SPEED] * cosines[ix];
		parts[which][YPOS] += parts[which][SPEED] * sines[ix];

		parts[which][DIR] += Math.random() * 30.0-15.0;

		jumped=0;
		if (parts[which][XPOS] > MAX_X) {
			parts[which][XPOS] = MIN_X;
			jumped=1;
		}
		if (parts[which][XPOS] < MIN_X) {
			parts[which][XPOS] = MAX_X;
			jumped=1;
		}
		if (parts[which][YPOS] > MAX_Y) {
			parts[which][YPOS] = MIN_Y;
			jumped=1;
		}
		if (parts[which][YPOS] < MIN_Y) {
			parts[which][YPOS] = MAX_Y;
			jumped=1;
		}
		parts[which][JUMPED] = (double)jumped;

	}


}

